
// sign
import config from '../config';

// GET请求
function GET (requestHandler, isShowLoading) {
  return request('GET', requestHandler, isShowLoading);
}

// POST请求
function POST (requestHandler, isShowLoading) {
  return request('POST', requestHandler, isShowLoading);
}

function request (method, requestHandler, isShowLoading = true) {
    // 加密
  let params = requestHandler.params;
  if (requestHandler.url.indexOf('login') === -1 && requestHandler.url.indexOf('share-day-step') === -1) {
    params.token = wx.getStorageSync('token').token;
  }
  console.log('url: ' + config.apiHost + '/' + requestHandler.url);
  console.log('params: ' + JSON.stringify(params));
  isShowLoading && wx.showLoading && wx.showLoading({title: '加载中...'});
  return new Promise((resolve, reject) => {
    config.apiHost = config.getApiHost();
    wx.request({
      url: config.apiHost + '/' + requestHandler.url,
      data: params,
      method: method, // OPTIONS, GET, HEAD, POST, PUT, DELETE, TRACE, CONNECT
      header: {
        'Content-Type': method === 'POST' ? 'application/x-www-form-urlencoded' : 'application/json'
      },
      success: function (res) {
        isShowLoading && wx.hideLoading && wx.hideLoading();
                // 解密
        resolve(res);
      },
      fail: function () {
                // 因为hide会让showToast隐藏
        isShowLoading && wx.hideLoading && wx.hideLoading();
        wx.showToast({
          title: '网络请求失败',
          duration: 1500
        });
        reject(new Error('Network request failed'));
                // throw new Error('Network request failed')
      },
      complete: function () {
      }
    });
  });
}

module.exports = {
  get: GET,
  post: POST
};
